﻿package {
	import flash.display.Sprite;
	import flash.display.Shape;
	import flash.display.GradientType;
	import flash.geom.Point;
	import flash.events.*;
	import flash.utils.Timer;
	import flash.text.*;
	import flash.filters.*;
	
	import flash.display.Stage;
	import flash.display.StageAlign;
	import flash.display.StageDisplayState;
	
	import Hexagonfield;
	
	public class Play extends Sprite {


		private var timer:Timer = new Timer(50,100);
		private var hex:Hexagonfield;
		private var running:Boolean = false;
		private var count:Number = 0;
		private var tf:TextField;
		private var butt:Play;
		private var over:Boolean = false;

		private var moveStep:Function = function(evt:TimerEvent):void{
				
				(function():void{
					count++;
					if(count<100){
						hex.setFrame(count);
					}
					else{
						running = false;
						setText("Play");
						timer.stop();
						timer.removeEventListener(TimerEvent.TIMER, moveStep);
						
						timer = new Timer(50,100);
						timer.addEventListener(TimerEvent.TIMER, moveStep);
						
						count = 0;
						hex.setFrame(99);
					}
					drawPlay();
				})();
			};

		public function Play(_hexField:Hexagonfield){
			hex = _hexField;
			
			timer.addEventListener(TimerEvent.TIMER, moveStep);
			
			this.x = 0;
			this.y = 0;
			//this.y = 283;
			
			butt = this;
			
			tf = new TextField();
			addChild(tf);
			
			setText("Play");
			
			addEventListener(MouseEvent.MOUSE_OVER,function():void{
				over = true;
				drawPlay();
			});
			
			addEventListener(MouseEvent.MOUSE_OUT,function():void{
				over = false;
				drawPlay();
			});
			
			addEventListener(MouseEvent.MOUSE_DOWN,function(ev:MouseEvent):void{
				butt.togglePlay();									  
			});

			addEventListener(MouseEvent.MOUSE_UP,function(ev:MouseEvent):void{});
		}
		
		public function togglePlay(){

			if(!running){
				running = true;
				setText("Pause");
				timer.start();
			}
			else{
				running = false;
				setText("Play");
				//timer.removeEventListener(TimerEvent.TIMER, moveStep);
				timer.stop();
				drawPlay();
			}
		}
		
		
		public function drawPlay(){
			
			graphics.clear();
			
			var pos:Number = 5+count*260/100;
			graphics.beginFill(120<<16 | 120<<8 | 120);
			graphics.drawRect(pos, -105, 2, 100);
			
			if(!running){
				graphics.beginFill(0<<16 | 140<<8 | 0);
			}
			else{
				graphics.beginFill(140<<16 | 0<<8 | 0);
			}
			graphics.drawRoundRect(0, 0, 270, 60, 30, 30);
			
			if(over){
				graphics.endFill();
				graphics.lineStyle(5,0xffcc00);
				graphics.drawRoundRect(0, 0, 270, 60, 30, 30);
			}
			
			graphics.endFill();
			
		}
		
		public function setText(_txt:String):void{
			removeChild(tf);
			
			var format:TextFormat = new TextFormat();
			format.font = "Verdana";
			format.color = 0xffffff;
			format.size = 34;
			tf = new TextField();
			tf.defaultTextFormat = format;
			tf.text = _txt;
			var temptextlength:Number = tf.textWidth;
			tf.x = 100;
			tf.y = 5;
			tf.height = 50;
			tf.width = 200 * _txt.length;
			tf.mouseEnabled = false;
			
			addChild(tf);
		}
	}
}